# $Id: Server.pm 29028 2009-10-17 22:03:47Z wsl $
# $URL: https://infix.uvt.nl/its-id/trunk/sources/aselect-perl/lib/Aselect/Server.pm $

use utf8;
use strict;
use warnings FATAL => 'all';

package Aselect::Server;

use Aselect::Generator -Base;
use Aselect::Database -mixin;

use Aselect::Util;

sub work {
	my %response = (result_code => '0030');

	my $req = $self->req;
	my $cfg = $self->cfg;

	$response{'a-select-server'} = $cfg->id || $req->virtual_host;

	my $request = $req->param('request');
	if(defined $request) {
		if($request eq 'authenticate') {
			my $url = $cfg->url;
			$url =~ s,/*$,/login,;

			my $app_url = $req->param('app_url');
			my $app_id = $req->param('app_id');

			my $rid = $self->random_hexbytes(8);
			$self->rid($rid, $app_id, $app_url);

			@response{qw(result_code rid as_url)} = ('0000', $rid, $url);
		} elsif($request eq 'verify_credentials') {
			my $credentials = $req->param('aselect_credentials');
			my $ticket = $self->ticket($credentials);
			if($ticket) {
				my $timeout = $cfg->timeout
					or die "No SessionTimeout configured\n";
				my $expires = int(($ticket->{stime} + $timeout) * 1000);
				@response{qw(result_code uid organization app_id tgt_exp_time)} =
					('0000', @$ticket{qw(username organization app_id)}, $expires);
				@response{qw(authsp authsp_level app_level)} = ('ldap', 10, 10);
				@response{qw(asp asp_level)} = @response{qw(authsp authsp_level)};
				$response{attributes} = $ticket->{attributes}
					if exists $ticket->{attributes};
			}
		}
	}

	$req->type('text/plain');
	$req->content(aselect_join(%response));
}
